// Created by John Bartlett, jbartlett@strangejourney.net

var ZeroBase=true;
var ListLenJSDefault=true;

/*
Supported Functions
ArrayAppend(ArrayVar,NewVal)
ArrayPrepend(ArrayVar,NewVal)
ArrayAvg(ArrayVar)
ArrayDeleteAt(ArrayVar,Position)
ArrayInsertAt(ArrayVar,Position,NewVal)
ArrayLen(ArrayVar)
ArrayMin(ArrayVar)
ArrayMax(ArrayVar)
ArrayResize(ArrayVar,MinimumSize)
ArraySet(ArrayVar,StartPos,EndPos,NewVal)
ArraySort(ArrayVar,SortType,SortOrder)
ArraySum(ArrayVar)
ArrayToList(ArrayVar,Delimiter)
ListToArray(List,Delimiter)
*/


/*
if (ZeroBase)
{
	print('ArrayAppend(1,2,3,4),5): [' + ArrayAppend(new Array(1,2,3,4),5) + '] > [1,2,3,4,5]');
	print('ArrayPrepend(1,2,3,4),0): [' + ArrayPrepend(new Array(1,2,3,4),0) + '] > [0,1,2,3,4]');
	print('ArrayAvg(1,2,3,A,4,5,6): [' + ArrayAvg(new Array(1,2,3,'A',4,5,6)) + '] > [3.5]');
	print('ArrayDeleteAt(A,B,C,D),2): [' + ArrayDeleteAt(new Array('A','B','C','D'),2) + '] > [A,B,D]');
	print('ArrayInsertAt(A,B,C,D),2,X): [' + ArrayInsertAt(new Array('A','B','C','D'),2,'X') + '] > [A,B,X,C,D]');
	if (ListLenJSDefault)
	{
		print('ArrayLen(1,2,3,4,5): [' + ArrayLen(new Array(1,2,3,4,5)) + '] > [5]');
	} else {
		print('ArrayLen(1,2,3,4,5): [' + ArrayLen(new Array(1,2,3,4,5)) + '] > [4]');
	}
	print('ArrayMin(10,20,5,A,2): [' + ArrayMin(new Array(10,20,5,'A',2)) + '] > [2]');
	print('ArrayMax(10,20,5,A,2): [' + ArrayMax(new Array(10,20,5,'A',2)) + '] > [20]');
	print('ArrayResize(1,2),4: [' + ArrayResize(new Array(1,2),4) + '] > [1,2,,]');
} else {
}
*/

function ArrayAppend(ArrayVar,NewVal)
{
	ArrayVar[ArrayVar.length]=NewVal;
	return ArrayVar;
}

function ArrayPrepend(ArrayVar,NewVal)
{
	var i=0;
	for (i=ArrayVar.length; i > 0; i--)
	{
		ArrayVar[i]=ArrayVar[i - 1];
	}
	ArrayVar[0]=NewVal;
	return ArrayVar;
}

function ArrayAvg(ArrayVar)
{
	var sum=0;
	var tot=0;
	var i=0;
	for (i=0; i < ArrayVar.length; i++)
	{
		ArrayVar[i]=Number(ArrayVar[i]);
		if (!isNaN(ArrayVar[i]))
		{
			tot++;
			sum=sum + ArrayVar[i];
		}
	}
	return sum / tot;
}

function ArrayDeleteAt(ArrayVar,Position)
{
	var NewArray=new Array();
	var x=0;
	var y=-1;
	if (!ZeroBase) Position--;
	for (x=0; x < ArrayVar.length; x++)
	{
		if (x != Position)
		{
			y++;
			NewArray[y]=ArrayVar[x];
		}
	}
	ArrayVar=NewArray;
	return NewArray;
}

function ArrayInsertAt(ArrayVar,Position,NewVal)
{
	var NewArray=new Array();
	var x=0;
	var y=-1;
	if (!ZeroBase) Position--;
	for (x=0; x < ArrayVar.length; x++)
	{
		if (x == Position)
		{
				y++;
				NewArray[y]=NewVal;
		}
		y++;
		NewArray[y]=ArrayVar[x];
	}
	ArrayVar=NewArray;
	return NewArray;
}

function ArrayLen(ArrayVar)
{
	var Len=ArrayVar.length;
	if (ZeroBase && !ListLenJSDefault) Len--;
	return Len;
}

function ArrayMin(ArrayVar)
{
	var MinVal=Number.MAX_VALUE;
	var i=0;
	var ok=false;
	for (i=0; i < ArrayVar.length; i++)
	{
		ArrayVar[i]=Number(ArrayVar[i]);
		if (!isNaN(ArrayVar[i]))
		{
			ok=true;
			if (ArrayVar[i] < MinVal) MinVal=ArrayVar[i];
		}
	}
	if (!ok) MinVal=0;
	return MinVal
}

function ArrayMax(ArrayVar)
{
	var MaxVal=Number.MIN_VALUE;
	var i=0;
	ok=false;
	for (i=0; i < ArrayVar.length; i++)
	{
		ArrayVar[i]=Number(ArrayVar[i]);
		if (!isNaN(ArrayVar[i]))
		{
			ok=true;
			if (ArrayVar[i] > MaxVal) MaxVal=ArrayVar[i];
		}
	}
	if (!ok) MaxVal=0;
	return MaxVal
}

function ArrayResize(ArrayVar,MinimumSize)
{
	var i=0;
	var ALen=ArrayVar.length;
	if (ZeroBase) MinimumSize--;
	if (ArrayVar.length >= MinimumSize) return ArrayVar;
	for (i=ALen; i <= MinimumSize; i++)
	{
		ArrayVar[i]=undefined;
	}
	return ArrayVar;
}

function ArraySet(ArrayVar,StartPos,EndPos,NewVal)
{
	var i=0;
	if (!ZeroBase)
	{
		StartPos--;
		EndPos--;
	}
	for (i=StartPos; i <= EndPos; i++)
	{
		ArrayVar[i]=NewVal;
	}
	return ArrayVar;
}

function ArraySort(ArrayVar,SortType,SortOrder)
{
	var x=0;
	var y=0;
	var Hold='';
	if (ArrayVar.length <= 1) return ArrayVar;
	for (x=0; x < ArrayVar.length - 1; x++)
	{
		for (y=x + 1; y < ArrayVar.length; y++)
		{
			if (SortType.toLowerCase() == 'numeric') eval('Result=Number(ArrayVar[' + x + ']) ' + Comp + ' Number(ArrayVar[' + y +'])');
			if (SortType.toLowerCase() == 'text') eval('Result=ArrayVar[' + x + '] ' + Comp + ' ArrayVar[' + y +']');
			if (SortType.toLowerCase() == 'textnocase')
			{
				if (ArrayVar[x] != ArrayVar[y] && ArrayVar[x].toLowerCase() == ArrayVar[y].toLowerCase())
				{
					eval('Result=ArrayVar[' + x + '] ' + Comp + ' ArrayVar[' + y +']');
				} else {
					eval('Result=ArrayVar[' + x + '].toLowerCase() ' + Comp + ' ArrayVar[' + y +'].toLowerCase()');
				}
			}
			if (Result)
			{
				Hold=ArrayVar[x];
				ArrayVar[x]=ArrayVar[y];
				ArrayVar[y]=Hold;
			}
		}
	}
	return ArrayVar;
}

function ArraySum(ArrayVar)
{
	var sum=0;
	for (i=0; i < ArrayVar.length; i++)
	{
		ArrayVar[i]=Number(ArrayVar[i]);
		if (!isNaN(ArrayVar[i])) sum=sum + ArrayVar[i];
	}
	return sum;
}

function ArrayToList(ArrayVar,Delimiter)
{
	var List='';
	var i=0;
	if (ArrayVar == null) return '';
	if (Delimiter == null) Delimiter=',';
	for (i=0; i < ArrayVar.length; i++)
	{
		List=ListAppend(List,ArrayVar[i],Delimiter);
	}
	return List;
}

function ListToArray(List,Delimiter)
{
	if (List == null) return new Array();
	if (Delimiter == null) Delimiter=',';
	if (List == '') return new Array();
	return List.split(Delimiter);
}
