// var ZeroBase=true;
// var ListLenJSDefault=true;

/*

Supported Functions
===================
ListSetAt(List,Position,NewValue,Delimiter)
ListGetAt(List,Position,Delimiter)
ListFind(List,SearchString,Delimiter)
ListFindNoCase(List,SearchString,Delimiter)
ListLen(List,Delimiter)
ListToArray(List,Delimiter)
ArrayToList(ArrayVar,Delimiter)
ListAppend(List,NewVal,Delimiter)
ListDeleteAt(List,Position,Delimiter)
ListFirst(List,Delimiter)
ListLast(List,Delimiter)
ListInsertAt(List,Position,NewVal,Delimiter)
ListPrepend(List,NewVal,Delimiter)
ListRest(List,Delimiter)
ListSort(List,SortType,SortOrder,Delimiter)

*/


function ReturnTime(i)
{
	var out='';
	var h=i.getHours() + 1;
	var m=i.getMinutes();
	
	if (h > 12)
	{
		out=h - 12 + ':';
	} else {
		out=h + ':';
	}
	if (m < 10) out=out + '0';
	out=out + m;
	if (h >= 12)
	{
		out=out + ' PM';
	} else {
		out=out + ' AM';
	}
	
	return out;
}


function Integer(i)
{
	var out=String(i);
	var idx=out.indexOf('.');
	if (idx == -1) return i;
	out=out.substr(0,idx);
	return Number(out);
}

function ValInt(ObjectValue,AllowComma)
{
	// Used internally by VaidateInteger

	//Returns true if value is a number or is NULL
	//otherwise returns false	
	
	if (ObjectValue.length == 0) return true;
	
	//Returns true if value is an integer defined as
	//   having an optional leading + or -.
	//   otherwise containing only the characters 0-9.
	var decimal_format = ".";
	var check_char;
	
	//The first character can be + -  blank or a digit.
	check_char = ObjectValue.indexOf(decimal_format)
	//Was it a decimal?
	if (check_char < 1) return ValFloat(ObjectValue,AllowComma); else return false;
}

function ValFloat(ObjectValue,AllowComma)
{
	// Used Internally by ValidateInt, ValidateFloat

	//Returns true if value is a number or is NULL
	//otherwise returns false	
	
	if (ObjectValue.length == 0) return true;
	
	//Returns true if value is a number defined as
	//   having an optional leading + or -.
	//   having at most 1 decimal point.
	//   otherwise containing only the characters 0-9.
	var start_format = " .+-0123456789";
	var number_format = " .0123456789";
	if (AllowComma == 1) number_format=number_format + ',';
	var check_char;
	var decimal = false;
	var trailing_blank = false;
	var digits = false;
	
	//The first character can be + - .  blank or a digit.
	check_char = start_format.indexOf(ObjectValue.charAt(0))
	//Was it a decimal?
	if (check_char == 1)
		decimal = true;
	else if (check_char < 1)
		return false;
	
	//Remaining characters can be only . or a digit, but only one decimal.
	for (var i = 1; i < ObjectValue.length; i++)
	{
		check_char = number_format.indexOf(ObjectValue.charAt(i))
		if (check_char < 0)
			return false;
		else if (check_char == 1)
		{
			if (decimal)		// Second decimal.
				return false;
			else
				decimal = true;
		}
		else if (check_char == 0)
		{
			if (decimal || digits) trailing_blank = true;
			// ignore leading blanks
		}
		else if (trailing_blank)
			return false;
		else
			digits = true;
	}	
	//All tests passed, so...
	return true
}

function ListSetAt(List,Position,NewValue,Delimiter)
{
	var NewList='';
	var ListArray='';
	if (!ZeroBase) Position--;
	if (List == null || Position == null) return '';
	if (Delimiter == null) Delimiter=',';
	ListArray=ListToArray(List,Delimiter);
	if (ListArray.length < Position || Position < 0) return List;
	ListArray[Position]=NewValue;
	return ArrayToList(ListArray,Delimiter);
}

function ListGetAt(List,Position,Delimiter)
{
	if (List == null || Position == null) return false;
	if (Delimiter == null) Delimiter=',';
	if (!ZeroBase) Position--;
	var ListArray=ListToArray(List,Delimiter);
	if (ListArray.length < Position || Position < 0) return '';
	return ListArray[Position];
}

function ListFind(List,SearchString,Delimiter)
{
	var loc=-1;
	if (List == null || SearchString == null) return -1;
	if (Delimiter == null) Delimiter=',';
	var ListArray=List.split(Delimiter);
	for (i=0; i < ListArray.length; i++)
	{
		if (ListArray[i] == SearchString) loc=i;
	}
	if (loc >= 0)
	{
		if (ZeroBase) return loc;
		return loc + 1;
	}
	return -1;
}

function ListLen(List,Delimiter)
{
	if (List == null) return 0;
	if (Delimiter == null) Delimiter=',';
	var ListArray=List.split(Delimiter);
	if (ZeroBase && !ListLenJSDefault) return ListArray.length - 1;
	return ListArray.length;
}

function ListToArray(List,Delimiter)
{
	if (List == null) return new Array();
	if (Delimiter == null) Delimiter=',';
	if (List == '') return new Array();
	return List.split(Delimiter);
}

function ArrayToList(ArrayVar,Delimiter)
{
	var List='';
	var i=0;
	if (ArrayVar == null) return '';
	if (Delimiter == null) Delimiter=',';
	for (i=0; i < ArrayVar.length; i++)
	{
		List=ListAppend(List,ArrayVar[i],Delimiter);
	}
	return List;
}

function ListAppend(List,NewVal,Delimiter)
{
	if (List == null) return List;
	if (NewVal == null) return List;
	if (Delimiter == null) Delimiter=',';
	if (List == '')
	{
		List=NewVal;
	} else {
		List=List + Delimiter + NewVal;
	}
	return List;
}

function ListDeleteAt(List,Position,Delimiter)
{
	var NewList='';
	var ListArray='';
	var i=0;
	if (List == null || Position == null) return '';
	if (Delimiter == null) Delimiter=',';
	if (!ZeroBase) Position--;
	ListArray=ListToArray(List,Delimiter);
	if (Position < 0 || Position + 1 > ListArray.length) return List;
	for (i=0; i < ListArray.length; i++)
	{
		if (i != Position) NewList=ListAppend(NewList,ListArray[i],Delimiter);
	}
	return NewList;
}

function ListFindNoCase(List,SearchString,Delimiter)
{
	return ListFind(List.toUpperCase(),SearchString.toUpperCase(),Delimiter);
}

function ListFirst(List,Delimiter)
{
	if (List == null || List == '') return '';
	var ListArray=ListToArray(List,Delimiter);
	return ListArray[0];
}

function ListLast(List,Delimiter)
{
	if (List == null || List == '') return '';
	var ArrayList=ListToArray(List,Delimiter);
	return ArrayList[ArrayList.length - 1];
}

function ListInsertAt(List,Position,NewVal,Delimiter)
{
	var NewList='';
	var ListArray='';
	var i=0;
	if (List == null || Position == null) return List;
	if (Delimiter == null) Delimiter=',';
	if (NewVal == null) NewVal='';
	if (!ZeroBase) Position--;
	ListArray=ListToArray(List,Delimiter);
	if (Position < 0 || Position > ListArray.length - 1) return List;
	if (Position < ListArray.length - 1)
	{
		for (i=ListArray.length; i > Position; i--)
		{
			ListArray[i]=ListArray[i - 1];
		}
	}
	ListArray[Position]=NewVal;
	return ArrayToList(ListArray,Delimiter);
}

function ListPrepend(List,NewVal,Delimiter)
{
	var HoldZeroBase=ZeroBase;
	ZeroBase=true;
	var tmp=ListInsertAt(List,0,NewVal,Delimiter);
	ZeroBase=HoldZeroBase;
	return tmp;
}

function ListRest(List,Delimiter)
{
	var HoldZeroBase=ZeroBase;
	ZeroBase=true;
	var tmp=ListDeleteAt(List,0,Delimiter);
	ZeroBase=HoldZeroBase;
	return tmp;
}

function ListSort(List,SortType,SortOrder,Delimiter)
{
	var x=0;
	var y=0;
	var ListArray='';
	var Comp='>';
	var Result='';
	var Hold='';
	if (List == null) return List;
	if (Delimiter == null) Delimiter=',';
	if (SortOrder == null) SortOrder='asc';
	if (ListFindNoCase('numeric,text,textnocase',SortType) == -1) return List;
	if (ListFindNoCase('asc,desc',SortOrder) == -1) return List;
	if (SortOrder == 'desc') Comp='<';
	ListArray=ListToArray(List,Delimiter);
	if (ListArray.length <= 1) return '';
	for (x=0; x < ListArray.length - 1; x++)
	{
		for (y=x + 1; y < ListArray.length; y++)
		{
			if (SortType.toLowerCase() == 'numeric') eval('Result=Number(ListArray[' + x + ']) ' + Comp + ' Number(ListArray[' + y +'])');
			if (SortType.toLowerCase() == 'text') eval('Result=ListArray[' + x + '] ' + Comp + ' ListArray[' + y +']');
			if (SortType.toLowerCase() == 'textnocase')
			{
				if (ListArray[x] != ListArray[y] && ListArray[x].toLowerCase() == ListArray[y].toLowerCase())
				{
					eval('Result=ListArray[' + x + '] ' + Comp + ' ListArray[' + y +']');
				} else {
					eval('Result=ListArray[' + x + '].toLowerCase() ' + Comp + ' ListArray[' + y +'].toLowerCase()');
				}
			}
			if (Result)
			{
				Hold=ListArray[x];
				ListArray[x]=ListArray[y];
				ListArray[y]=Hold;
			}
		}
	}
	return ArrayToList(ListArray,Delimiter);
}


